AUTOMOUNT=true
#默认不动
SKIPMOUNT=false
#如果想启用system.prop的参数，则改为true
PROPFILE=true
#开机前执行的命令，想启用则改为true
POSTFSDATA=true
#开机后执行的命令，想启用则改为true
LATESTARTSERVICE=true

ui_print "MIUI12.5 专用优化"

ui_print "卸载请在magisk关闭并重启模块"



##########################################################################################
# Permissions
MIUI="`getprop ro.miui.ui.version.name`"
ID="`grep_prop id $TMPDIR/module.prop`"
MarketName="`getprop ro.product.system.marketname`"
Device="`getprop ro.product.system.device`"
Model="`getprop ro.product.system.model`"
# 系统版本检测
echo "- 系统版本: $MIUI"
echo "- 型号: $MarketName"
echo "- Device: $Device"
echo "- Model: $Model"
##########################################################################################
on_install() {
  ui_print "- 正在释放文件"
  unzip -o "$ZIPFILE" 'system/*' -d $MODPATH >&2
  unzip -o "$ZIPFILE" -x 'META-INF/*' -d $MODPATH >&2
  
  
}

# 将 $ZIPFILE 提取到 $MODPATH
#ui_print "- 开始安装ADHost"

set_permissions() {

  set_perm_recursive  $MODPATH  0  0  0755  0644
  set_perm  $MODPATH/system/bin/logd  0  0  0550
}

ui_print "- 优化参数中..."
# 拷贝挂载指定路径文件
cp -rf /system/vendor/etc/device_features/* $MODPATH/system/vendor/etc/device_features
cp -rf /system/etc/device_features/* $MODPATH/system/etc/device_features


tar -xf $MODPATH/tools.tar.xz -C $TMPDIR >&2
chmod -R 0755 $TMPDIR/tools
alias keycheck="$TMPDIR/tools/$ARCH32/keycheck"

keytest() {
  ui_print "- 音量键测试"
  ui_print "   请按任意音量键:"
  if (timeout 3 /system/bin/getevent -lc 1 2>&1 | /system/bin/grep VOLUME | /system/bin/grep " DOWN" > $TMPDIR/events); then
    return 0
  else
    ui_print "   再试一次:"
    timeout 3 keycheck
    local SEL=$?
    [ $SEL -eq 143 ] && abort "   未检测到音量键!" || return 1
  fi
}

chooseport() {
  # Original idea by chainfire @xda-developers, improved on by ianmacd @xda-developers
  #note from chainfire @xda-developers: getevent behaves weird when piped, and busybox grep likes that even less than toolbox/toybox grep
  while true; do
    /system/bin/getevent -lc 1 2>&1 | /system/bin/grep VOLUME | /system/bin/grep " DOWN" > $TMPDIR/events
    if (`cat $TMPDIR/events 2>/dev/null | /system/bin/grep VOLUME >/dev/null`); then
      break
    fi
  done
  if (`cat $TMPDIR/events 2>/dev/null | /system/bin/grep VOLUMEUP >/dev/null`); then
    return 0
  else
    return 1
  fi
}

chooseportold() {
  # Keycheck binary by someone755 @Github, idea for code below by Zappo @xda-developers
  # Calling it first time detects previous input. Calling it second time will do what we want
  while true; do
    keycheck
    keycheck
    local SEL=$?
    if [ "$1" == "UP" ]; then
      UP=$SEL
      break
    elif [ "$1" == "DOWN" ]; then
      DOWN=$SEL
      break
    elif [ $SEL -eq $UP ]; then
      return 0
    elif [ $SEL -eq $DOWN ]; then
      return 1
    fi
  done
}

# Have user option to skip vol keys
OIFS=$IFS; IFS=\|; MID=false; NEW=false
case $(echo $(basename $ZIPFILE) | tr '[:upper:]' '[:lower:]') in
  *novk*) ui_print "- 跳过音量键 -";;
  *) if keytest; then
       VKSEL=chooseport
     else
       VKSEL=chooseportold
       ui_print "  ! 检测到遗留设备! 使用旧的 keycheck 方案"
       ui_print " "
       ui_print "- 音量键录入 -"
       ui_print "  请按音量+键:"
       $VKSEL "UP"
       ui_print "  请按音量–键"
       $VKSEL "DOWN"
     fi;;
esac
IFS=$OIFS

ui_print "是否精简系统"
ui_print "  音量+ = 精简"
ui_print "  音量– = 不精简"
if $VKSEL; then
  ui_print "已选择精简"
  REPLACE="

/system/priv-app/BuiltInPrintService
/system/priv-app/ViPERFX
/system/product/app/PhotoTable
/system/app/BasicDreams
/system/app/ModemTestBox
/system/app/TouchAssistant
/system/app/talkback
/system/app/AntHalService
/system/product/priv-app/EmergencyInfo
/system/priv-app/MiRcs
/system/app/mi_connect_service
/system/app/WMService
/system/app/WAPPushManager
/system/app/Traceur
/system/app/MiuiBugReport
/system/priv-app/MiService
/system/app/MiuiDaemon
/system/app/Userguide
/system/priv-app/UserDictionaryProvider
/system/priv-app/BlockedNumberProvider
/system/app/Stk
/system/app/SimAppDialog
/system/app/SimContact
/system/app/CatchLog
/system/app/AnalyticsCore
/system/app/MSA
/system/priv-app/NewHome
/system/app/HybridAccessory
/system/app/HybridPlatform
/system/app/PrintSpooler
/system/app/BuiltInPrintService
/system/app/goodix_sz
/system/priv-app/MiShare
/system/priv-app/QuickSearchBox
/system/app/AiAsstVision
/system/priv-app/YellowPage
/system/app/MiPlayClient
/system/app/MiLinkService2
/system/priv-app/WfdService
/system/app/mab
/system/app/com.miui.qr
/system/app/KSICibaEngine
/system/priv-app/Stk1
"
pm disable com.xiaomi.payment
pm disable com.miui.securityinputmethod
pm disable com.miui.accessibility
pm disable com.miui.cloudbackup
pm disable com.miui.translation.xmcloud
pm disable com.miui.translation.kingsoft
pm disable com.miui.translation.xmcloud
pm disable com.miui.translation.youdao
pm disable com.miui.translationservice
pm disable com.debug.loggerui
pm disable com.mobiletools.systemhelper
pm disable com.xiaomi.mirror
pm disable com.miui.greenguard
pm disable com.miui.contentextension
pm disable com.unionpay.tsmservice.mi
#冻结耗电
pm disable com.tencent.mobileqq/com.tencent.proxyinner.plugin.loader.PluginToolProcessService
pm disable com.tencent.mobileqq/com.tencent.av.service.AVServiceForQQ
pm disable com.tencent.mobileqq/com.tencent.av.service.UtilsServiceForAV
pm disable com.tencent.mobileqq/cooperation.qzone.QzonePluginProxyService
pm disable com.tencent.mobileqq/cooperation.qzone.video.QzoneVideoPluginProxyService
pm disable com.tencent.mobileqq/cooperation.qzone.remote.logic.QzoneWebPluginProxyService
pm disable com.tencent.mobileqq/cooperation.qzone.QzonePluginPublishQueueProxyService
pm disable com.tencent.mobileqq/cooperation.qzone.QzonePictureViewerProxyService
pm disable com.tencent.mobileqq/com.tencent.mobileqq.music.QQPlayerService
pm disable com.tencent.mobileqq/cooperation.qwallet.plugin.QWalletPluginProxyService
pm disable com.tencent.mobileqq/cooperation.groupvideo.GVideoProxyService
pm disable com.tencent.mobileqq/cooperation.groupvideo.GVideoSmallScreenProxyService
pm disable com.tencent.mobileqq/cooperation.groupvideo.GVideoProxyUtilService
pm disable com.tencent.mobileqq/com.tencent.mobileqq.mini.app.InternalAppBrandTaskPreloadReceiver
pm disable com.tencent.mobileqq/com.tencent.mobileqq.mini.app.AppBrandTaskPreloadReceiver
pm disable com.tencent.mobileqq/com.tencent.mobileqq.mini.app.AppBrandTaskPreloadReceiver1
pm disable com.tencent.mobileqq/com.tencent.mobileqq.mini.app.AppBrandTaskPreloadReceiver2
pm disable com.tencent.mobileqq/com.tencent.mobileqq.mini.app.AppBrandTaskPreloadReceiver3
pm disable com.tencent.mobileqq/com.tencent.mobileqq.mini.app.AppBrandTaskPreloadReceiver4
pm disable com.tencent.mobileqq/com.tencent.mobileqq.mini.app.AppBrandTaskPreloadReceiver5
pm disable com.tencent.mobileqq/com.tencent.mobileqq.mini.app.AppBrandTaskPreloadReceiver6
pm disable com.tencent.mobileqq/com.tencent.mobileqq.mini.app.AppBrandTaskPreloadReceiver7
pm disable com.tencent.mobileqq/com.tencent.mobileqq.ar.ArConfigService
pm disable com.tencent.mobileqq/com.tencent.mobileqq.ar.ARGlobalConfigService
pm disable com.tencent.mobileqq/cooperation.qzone.plugin.QZonePatchService
pm disable com.tencent.mm/com.tencent.mm.sandbox.updater.AppUpdaterUI
pm disable com.tencent.mm/com.tencent.mm.sandbox.updater.AppInstallerUI
pm disable com.tencent.mm/com.tencent.mm.plugin.nfc_open.ui.NfcWebViewUI
pm disable com.tencent.mm/com.tencent.mm.plugin.appbrand.task.AppBrandTaskPreloadReceiver
pm disable com.tencent.mm/com.tencent.mm.plugin.appbrand.task.AppBrandTaskPreloadReceiver1
pm disable com.tencent.mm/com.tencent.mm.plugin.appbrand.task.AppBrandTaskPreloadReceiver2
pm disable com.tencent.mm/com.tencent.mm.plugin.appbrand.task.AppBrandTaskPreloadReceiver3
pm disable com.tencent.mm/com.tencent.mm.plugin.appbrand.task.AppBrandTaskPreloadReceiver4
pm disable com.tencent.mm/com.tencent.mm.booter.MMReceivers$SandBoxProcessReceiver

pm disable com.miui.analytics
pm disable com.miui.systemAdSolution

fi
ui_print "是否冻结万象息屏（有屏幕指纹不建议冻结 ，冻结后无法使用指纹）"
ui_print "  音量+ = 精简"
ui_print "  音量– = 不精简"
if $VKSEL; then
  ui_print "已选择冻结"
pm disable com.miui.aod
else
  ui_print "已选择不冻结"
pm enable com.miui.aod
fi
ui_print "是否冻结小爱同学和部分相关组件（其余组件无法完全冻结，需禁用）"
ui_print "  音量+ = 精简"
ui_print "  音量– = 不精简"
if $VKSEL; then
  ui_print "已选择冻结"
pm disable com.miui.voiceassist
pm disable com.mediatek.voiceunlock
else
  ui_print "已选择不冻结"
pm enable com.miui.voiceassist
pm enable com.mediatek.voiceunlock
fi

ui_print "是否冻结钱包和小米智能卡(使用小米系列NFC功能不建议关闭)"
ui_print "  音量+ = 精简"
ui_print "  音量– = 不精简"
if $VKSEL; then
  ui_print "已选择冻结"
pm disable com.mipay.wallet
pm disable com.miui.tsmclient
else
  ui_print "已选择不冻结"
pm enable com.mipay.wallet
pm enable com.miui.tsmclient
fi


ui_print "是否冻结智能助理(负一屏耗电大户若无所谓桌面组件效果可以选择冻结）"
ui_print "  音量+ = 精简"
ui_print "  音量– = 不精简"
if $VKSEL; then
  ui_print "已选择冻结"
pm disable com.miui.personalassistant
else
  ui_print "已选择不冻结"
pm enable com.miui.personalassistant
fi

# DC调光
sleep 0.3
sed -i '/<\/features>/i\    <bool name=\"support_dc_backlight\">true<\/bool>' $MODPATH/system/etc/device_features/*
sed -i '/<\/features>/i\    <bool name=\"support_dc_backlight\">true<\/bool>' $MODPATH/system/vendor/etc/device_features/*
echo "- 开启支持: DC调光"






##########################################################################################
# 权限设置
##########################################################################################

  #如果添加到此功能，请将其删除

  # 请注意，magisk模块目录中的所有文件/文件夹都有$MODPATH前缀-在所有文件/文件夹中保留此前缀
  # 一些例子:
  
  # 对于目录(包括文件):
  # set_perm_recursive  <目录>                <所有者> <用户组> <目录权限> <文件权限> <上下文> (默认值是: u:object_r:system_file:s0)
  
  # set_perm_recursive $MODPATH/system/lib 0 0 0755 0644
  # set_perm_recursive $MODPATH/system/vendor/lib/soundfx 0 0 0755 0644

  # 对于文件(不包括文件所在目录)
  # set_perm  <文件名>                         <所有者> <用户组> <文件权限> <上下文> (默认值是: u:object_r:system_file:s0)
  
  # set_perm $MODPATH/system/lib/libart.so 0 0 0644
  # set_perm /data/local/tmp/file.txt 0 0 644

  # 权限设置 longlong
  set_perm_recursive $MODPATH 0 0 0755 0644
  set_perm $MODPATH/service.sh 0 0 777
  set_perm $MODPATH/post-fs-data.sh 0 0 777
  set_perm $MODPATH/uninstall.sh 0 0 777

#add_service_sh $MOD_FILES_DIR/service.sh
#mkdir -p $MODPATH/system/vendor/bin
#cp -rf $MOD_FILES_DIR/system/* $MODPATH/system/aaa


##########################################################################################
# Custom Functions
##########################################################################################


  unzip -o "$ZIPFILE" 'system/*' -d $MODPATH >&2
  set_perm_recursive  $MODPATH  0  0  0755  0644
  ui_print " "
  sleep 0.5
  ABajiang=$MODPATH/module.prop
  time0=$(date "+%Y-%m-%d %H:%M")
  echo "- 当前时间: $time0"
  echo "$time0" >> $ABajiang
  sleep 1
#!/system/bin/sh


